/*

Copyright 2001 
by Constantin Loizides <constantin.loizides@isg.de>


This file is part of the journaling-filesystem fragmentation project.
You find the files belonging to that project in the Makefile
coming together with this file.

Source code concerning that project is free software; 
you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
USA

*/

#include "cl_string.h"

cl_String cl_String::toString(int num) 
{
	char *c=new char[20];
	sprintf(c,"%i",num);
	cl_String res=(c);
	delete c;
	//res+='\0';	
	return res;
}

cl_String cl_String::toString(unsigned int num) 
{
	char *c=new char[20];
	sprintf(c,"%u",num);
	cl_String res=(c);
	delete c;
	//res+='\0';	
	return res;
}

cl_String cl_String::toString(long num) 
{
	char *c=new char[20];
	sprintf(c,"%ld",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

cl_String cl_String::toString(long long num) 
{
	char *c=new char[20];
	sprintf(c,"%lld",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

cl_String cl_String::toString(unsigned long num) 
{
	char *c=new char[20];
	sprintf(c,"%lu",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

cl_String cl_String::toString(unsigned long long num) 
{
	char *c=new char[20];
	sprintf(c,"%llu",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

cl_String cl_String::toString(float num) 
{
	char *c=new char[20];
	sprintf(c,"%f",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

cl_String cl_String::toString(double num) 
{
	char *c=new char[20];
	sprintf(c,"%e",num);
	cl_String res=(c);
	//res+='\0';	
	delete c;
	return res;
}

#ifndef HAVE_FORTRAN__
ostream& operator<<(ostream &os, const cl_String &s)
{
	return os << (const char*)s;
};

istream& operator>>(istream &is, cl_String &s)
{
	char c;
	while(is.get(c))
	{
		if(c=='\n') break;
		s+=c;
	}
	s+='\0';	
	return is;
};
#endif

int operator==(const cl_String &s, const cl_String &t)
{
	return (strcmp((const char *)s, (const char *)t)==0);
};

int operator!=(const cl_String &s, const cl_String &t)
{
	return (strcmp((const char *)s, (const char *)t)!=0);
};

int operator==(const cl_String &s, const char* t)
{
	return (strcmp((const char *)s, t)==0);
};

int operator!=(const cl_String &s, const char *t)
{
	return (strcmp((const char *)s, t)!=0);
};

template class cl_Array<cl_String>;

//#define TESTSTR
#ifdef TESTSTR
#include <fstream.h> 
int main(int argc,char *argv[])
{
	ifstream f_in;
	f_in.open(argv[1]);
	
	cl_String a,b,c,e,f,g,h;

	while (!f_in.eof())
	{
		cl_String test;
		test.clear();
		f_in>>test;
		b=(char*)test;
		cl_String n(b);
		b.clear();
		b="Consti";
		n+=(int)n.length();
		n+=b;
		cout << n << endl;
	}

	a="HAllo";
	b=" Consti";
	c=a;
	c+=b;
	c+=1923;
	char *test="hfkjahfakhfkjezurwzeriuwzeriwfkjdhfezuirzf";
	cl_String d(test);
	cout << a << b << c << d <<endl;
}
#endif
